Request

Response

    Bids
    GET

    bids/{bidId}

    Retrieves the specified bid. A bid is a proposal submitted by a bidder in response to an invitation to bid on a project’s bid package.

    Resource Information

    Method and URI
    GET
    https://developer.api.autodesk.com/construction/buildingconnected/v2/bids/{bidId}
    Authentication Context
    User context required
    Required OAuth Scopes
    data:read
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow.
    * Required

    Request

    URI Parameters

    bidId
    string
    The unique ID of the bid.

    Request

    Query String Parameters

    includePrivateAttachments
    boolean
    If true, the privateAttachments field is included in the response. Otherwise, the field is omitted from the response.

    Response

    HTTP Status Code Summary

    200
    OK
    OK
    400
    Bad Request
    The parameters of the requested operation are invalid or there are missing line items.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource could not be found.
    429
    Too Many Requests
    Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Body Structure (200)

    Expand all
    id
    string
    The unique bid ID.

    Max length: 24

    projectId
    string
    Unique ID of the project to which the bid is applied.

    Max length: 24

    bidPackageId
    string
    The unique ID of the bid package associated with the bid.

    Max length: 24

    inviteId
    string
    The unique ID of the invite associated with the bid.

    Max length: 24

    bidderCompanyId
    string
    The unique ID of the bidding company.

    Max length: 24

    currentAccLinkedProjectId
    string
    The project ID of the Forma project currently linked to from this bid’s BuildingConnected project.
    creatorType
    enum:string
    Indicates whether the bid creator was the project host or the bidder. Possible values:
    • HOST: The team that owns the project being bid on. This includes bids created using the BuildingConnected API.
    • BIDDER: An individual bidder on the project.
    notes
    string
    Notes provided on the proposal.
    total
    number
    A numeric value representing the total cost of the proposal not including any plugs, alternates, or other extra cost items. Combine this value with the project’s defaultCurrency to determine the monetary value of the proposal.
    leveledTotal
    number
    A numeric value representing the total cost of the proposal after bid levelling modifications are included. Combine this value with the project’s defaultCurrency to determine the leveled monetary value of the proposal.
    createdAt
    datetime: ISO 8601
    The date and time that the bid was created, in ISO 8601 format.
    updatedAt
    datetime: ISO 8601
    The date and time that the bid was last updated, in ISO 8601 format.
    submittedAt
    datetime: ISO 8601
    The date and time that the bid was submitted, in ISO 8601 format.
    attachments
    array: string
    An array of IDs of the files that are attached to the bid proposal. These IDs can be used with the GET bids/:bidId/attachments/:attachmentId endpoint to obtain additional information about the file, including a signed download URL.

    Max 50 attachmemts per bid.

    revision
    number
    The revision number of the bid. The first bid submitted by the bidder for a given bid package has a revision number of 0 (zero). Each time the bidder submits an updated bid, the new bid’s revision number is incremented by one.
    createdBy
    string
    The user ID of the user who created the bid. This bidder can be a internal user or an invitee.

    Max length: 24

    submittedBy
    string
    The user ID of the user who submitted the bid. This bidder can be a internal user or an invitee.

    Max length: 24

    lineItems
    object
    An array of line items that comprise the bid.

    Max 100 line items per page.

    pagination
    object
    The pagination details of a response.
    limit
    int
    The maximum number of records to return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last or only page is returned.
    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    nextUrl
    string
    The URL path that returns the next page of data.
    results
    array: object
    The array of bid line items
    id
    string
    The unique ID of the line item. This value is null if it’s the default line item.

    Max length: 24

    type
    enum:string
    The line item’s type.

    The possible values have the following UI equivalents:

    • ACKNOWLEDGMENT — General Acknowledgments
    • ADDENDUM — Scope-Specific Information and Unit Costs
    • ALTERNATE — Alternates
    • BONDING — Bond Information
    • CERTIFICATION — Certifications
    • COST_BREAKDOWN — Line Items
    • DISCLAIMER — Disclaimers and Clarifications
    • INCLUSION — Inclusions
    • LABOR_RATE — Labor Rates
    • MARKUP — Fees and Markups
    • SCOPE_CLARIFICATION — Scope-Specific Clarifications
    description
    string
    A description of the line item.
    section
    string
    The bid section that the line item is under. This value is null if the item is not under a section.
    isRequired
    boolean
    Indicates whether the item must be included in the bid. Possible values:
    • true: The item must be included.
    • false: The item is optional.
    isCustom
    boolean
    Indicates whether the item is a custom item added by the bidder instead of being on the bid form. Possible values:
    • true: The item was added by the bidder.
    • false: The item was on the bid form.
    unit
    enum:string
    The unit format of the bid line item.

    The possible values of this field depend on the value of the line item’s type field. Each possible line item type is listed, followed by the possible values of unit for that type:

    • ACKNOWLEDGMENT — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • ADDENDUM — TEXT, YES_NO, PER_ACRE, PER_AMP, PER_BOARD_FT, PER_CUBIC_FT, PER_CUBIC_METER, PER_CUBIC_YARD, PER_DAY, PER_EACH, PER_FLOOR, PER_GALLON, PER_GROSS_SQUARE_FT, PER_GROSS_SQUARE_METER, PER_HOUR, PER_KILOGRAM, PER_LINEAR_FT, PER_LINEAR_METER, PER_LINEAR_YARD, PER_LITER, PER_LOT, PER_METRIC_TON, PER_MONTH, PER_POUND, PER_RISER, PER_SQUARE_FT, PER_SQUARE_METER, PER_SQUARE_YARD, PER_SQUARE_YARD_INCH, PER_STALL, PER_STOP, PER_TON, PER_WATT, PER_WEEK, TOTAL_COST_ONLY
    • ALTERNATE — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TEXT, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • BONDING — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • CERTIFICATION — TEXT, YES_NO
    • COST_BREAKDOWN — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, GROSS_SQUARE_METERS, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • DISCLAIMER — Converted to null
    • INCLUSION — YES_NO_WITH_ADJUSTMENT
    • LABOR_RATE — PER_HOUR, PER_DAY, PER_WEEK
    • MARKUP — PERCENTAGE, TOTAL_COST_ONLY
    • SCOPE_CLARIFICATION — Converted to null

    Note that the value TOTAL_COST_ONLY is used for a lump sum line item.

    code
    string
    A code associated with the line item.
    quantity
    number
    The quantity of the line item.

    Note that this field is relevant only under the following conditions (otherwise it is null):

    • The value of type is ALTERNATE or COST_BREAKDOWN.
    • The value of unit is neither TEXT nor TOTAL_COST_ONLY.
    isQuantityFixed
    boolean
    Indicates whether the line item quantity is fixed. Possible values:
    • true: The quantity is fixed, and bidders cannot change it.
    • false: The quantity can be changed by bidders.
    unitCost
    number
    The cost per unit of the line item. This is not the total cost of the line item.

    Note that this field is relevant only under the following conditions (otherwise it is null):

    • The value of type is ALTERNATE or COST_BREAKDOWN.
    • The value of unit is neither TEXT nor TOTAL_COST_ONLY.
    value
    one of
    The total value of the line item. Note the following requirements:
    • If unit is TEXT, YES_NO, or YES_NO_WITH_ADJUSTMENT, this field is a string. Otherwise, it is a number.
    • If type is SCOPE_CLARIFICATION or DISCLAIMER, this field is null.
    • If type is ALTERNATE or COST_BREAKDOWN, this field depends on the value of quantity:

      • If quantity is null, value can be set to the value that the bidder entered directly.
      • If quantity is not null, value is not relevant. The total value is calculated by multiplying quantity and unitCost.
    0
    string
    A text value, used when the line item’s unit is TEXT, YES_NO, or YES_NO_WITH_ADJUSTMENT.
    1
    number
    A numeric value, used for all other unit types.
    plugs
    object
    An array of plugs (adjustments) in the bid, which were applied on the Bid Levelling tab of BuildingConnected Pro.

    Max 100 plugs per page.

    pagination
    object
    The pagination details of a response.
    limit
    int
    The maximum number of records to return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last or only page is returned.
    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    nextUrl
    string
    The URL path that returns the next page of data.
    results
    array: object
    The array of plugs associated with the bid
    id
    string
    The unique ID of the plug.

    Max length: 24

    quantity
    number
    The adjusted quantity of the associated line item.

    Note that this value is null under either of the following conditions:

    • The value of the line item’s type is neither ALTERNATE nor COST_BREAKDOWN.
    • The value of the line item’s unit is TOTAL_COST_ONLY or TEXT.
    unitCost
    number
    The adjusted cost per unit of the associated line item. This is not the total cost of the line item.

    Note that this value is null under either of the following conditions:

    • The value of the line item’s type is neither ALTERNATE nor COST_BREAKDOWN.
    • The value of the line item’s unit is TOTAL_COST_ONLY or TEXT.
    value
    one of
    The adjusted value of the line item. Note the following requirements:
    • If the line item’s unit is TEXT, YES_NO, or YES_NO_WITH_ADJUSTMENT, this field is a string. Otherwise, it is a number.
    • If the line item’s type is SCOPE_CLARIFICATION or DISCLAIMER, this field is null.
    • If the line item’s type is ALTERNATE or COST_BREAKDOWN, this field contains the adjusted total cost. In that case:

      • If the adjusted value of quantity is null, value is the value that was entered directly.
      • If the adjusted value of quantity is not null, value is not relevant. The total value is calculated by multiplying quantity and unitCost.
    0
    string
    The adjusted value as a string. Applies when the line item’s unit is TEXT, YES_NO, or YES_NO_WITH_ADJUSTMENT.

    Max length: 65536

    1
    number
    The adjusted value as a number. Applies for all other unit types.
    createdBy
    string
    User ID of the user who first created the plug.

    Max length: 24

    updatedBy
    string
    User ID of the user who most recently updated the plug.

    Max length: 24

    createdAt
    datetime: ISO 8601
    The date and time that the plug was created, in ISO 8601 format.
    updatedAt
    datetime: ISO 8601
    The date and time that the plug was last updated, in ISO 8601 format.
    lineItemFingerprint
    object
    Details that identify a line item.
    type
    enum:string
    The line item’s type. Possible values: ADDENDUM, ALTERNATE, COST_BREAKDOWN, INCLUSION, ACKNOWLEDGMENT, BONDING, CERTIFICATION, MARKUP, LABOR_RATE
    description
    string
    The description of the line item. This string is all lowercase.

    Max length: 65536

    section
    string
    The bid section that the line item is under. This string is all lowercase.

    Note that this value is null if the item is not under a section.

    Max length: 65536

    unit
    enum:string
    The unit format of the line item. Possible values: ACRES, ADD_DEDUCT, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, GROSS_SQUARE_METERS, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, PERCENTAGE, PER_ACRE, PER_AMP, PER_BOARD_FT, PER_CUBIC_FT, PER_CUBIC_METER, PER_CUBIC_YARD, PER_DAY, PER_EACH, PER_FLOOR, PER_GALLON, PER_GROSS_SQUARE_FT, PER_GROSS_SQUARE_METER, PER_HOUR, PER_KILOGRAM, PER_LINEAR_FT, PER_LINEAR_METER, PER_LINEAR_YARD, PER_LITER, PER_LOT, PER_METRIC_TON, PER_MONTH, PER_POUND, PER_RISER, PER_SQUARE_FT, PER_SQUARE_METER, PER_SQUARE_YARD, PER_SQUARE_YARD_INCH, PER_STALL, PER_STOP, PER_TON, PER_WATT, PER_WEEK, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TEXT, TONS, TOTAL_COST_ONLY, WATTS, WEEKS, YES_NO, YES_NO_WITH_ADJUSTMENT
    code
    string
    The code associated with the line item. This string is all lowercase.

    Note that this value is null if type is not COST_BREAKDOWN.

    Max length: 65536

    privateAttachments
    array: string
    An array of IDs of the private files that are attached to the bid. These IDs can be used with the GET bids/:bidId/attachments/:attachmentId endpoint to obtain additional information about the file, including a signed download URL.

    Max 50 attachmemts per bid.

    This field will only be present if the “includePrivateAttachments” query parameter is true.

    Example

    OK

    Request

    curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/bids/:bidId' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a'
    

    Response

    {
      "id": "611ee35b3935e500a8b18c8a",
      "projectId": "59d2bd7440b36a0da258f24d",
      "bidPackageId": "590dd127b359f408f190b5a7",
      "inviteId": "590dd527b359f408f191b5b6",
      "bidderCompanyId": "51bea397f5846f95994b1da7",
      "currentAccLinkedProjectId": "00f1b796-293a-4c1e-9474-f09711011426",
      "creatorType": "BIDDER",
      "notes": "Notes about bid",
      "total": 5000,
      "leveledTotal": 10000,
      "createdAt": "2021-08-19T23:07:16.083Z",
      "updatedAt": "2021-08-19T23:07:16.083Z",
      "submittedAt": "2021-08-19T23:08:32.075Z",
      "attachments": [
        "60cea42b3934f500a8b29c7b"
      ],
      "revision": 0,
      "createdBy": "5d8104b87e392d56e1e4b4ca",
      "submittedBy": "5d8104b87e392d56e1e4b4ca",
      "lineItems": {
        "pagination": {
          "limit": 100,
          "cursorState": "eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9",
          "nextUrl": "https://developer.api.autodesk.com/construction/buildingconnected/v2/projects?cursorState=eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9"
        },
        "results": [
          {
            "id": "53811754d3a604966df72247",
            "type": "COST_BREAKDOWN",
            "description": "Duct Insulation",
            "section": "Furnish & Install",
            "isRequired": true,
            "isCustom": false,
            "unit": "HOURS",
            "code": "D2",
            "quantity": 10,
            "isQuantityFixed": true,
            "unitCost": 500,
            "value": 10000
          }
        ]
      },
      "plugs": {
        "pagination": {
          "limit": 100,
          "cursorState": "eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9",
          "nextUrl": "https://developer.api.autodesk.com/construction/buildingconnected/v2/projects?cursorState=eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9"
        },
        "results": [
          {
            "id": "5f8104b87e392d56e1e4b4ad",
            "quantity": 20,
            "unitCost": 500,
            "value": 10000,
            "createdBy": "5f8104b87e392d56e1e4f7ad",
            "updatedBy": "5f8104b87e392d56e1e4f7ad",
            "createdAt": "2021-08-19T23:07:16.083Z",
            "updatedAt": "2021-08-20T23:07:16.083Z",
            "lineItemFingerprint": {
              "type": "COST_BREAKDOWN",
              "description": "duct insulation",
              "section": "furnish & install",
              "unit": "HOURS",
              "code": "d2"
            }
          }
        ]
      },
      "privateAttachments": [
        "60cea42b3934f500a8b29c7b"
      ]
    }
    
    Show More